# $Id:$

%extern{
#include "dns_pac.h"	// for DNS_Analyzer
%}

%include bro.pac

analyzer DNS_on_TCP withcontext {
	analyzer:	DNS_TCP_Analyzer;
	flow:		DNS_TCP_Flow;
};

type DNS_TCP_PDU(is_orig: bool) = record {
	msglen:		uint16;
	msg:		bytestring &length = msglen;
} &byteorder = bigendian, &length = 2 + msglen, &let {
	deliver: bool = $context.analyzer.deliver_dns_message(is_orig, msg);
};

analyzer DNS_TCP_Analyzer(bro_analyzer: BroAnalyzer) {
	upflow = DNS_TCP_Flow(true);
	downflow = DNS_TCP_Flow(false);

	%member{
		DNS::DNS_Analyzer *abstract_dns_analyzer_;
	%}

	%init{
		abstract_dns_analyzer_ = new DNS::DNS_Analyzer(bro_analyzer);
	%}

	%cleanup{
		delete abstract_dns_analyzer_;
	%}

	function deliver_dns_message(is_orig: bool, msg: const_bytestring): bool
		%{
		abstract_dns_analyzer_->NewData(is_orig, msg.begin(), msg.end());
		return true;
		%}
};

flow DNS_TCP_Flow(is_orig: bool) {
	flowunit = DNS_TCP_PDU(is_orig) withcontext(analyzer, this);
};
